Attribute VB_Name = "modMain"
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Private Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long
Private Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public Enum SpecialFolderConstants
    sfDesktop = &H0
    sfTemporary = &H1
    sfPrograms = &H2
    sfWindows = &H3
    sfSystem = &H4
    sfDocuments = &H5
    sfFavorites = &H6
    sfStartUp = &H7
    sfRecent = &H8
    sfSendTo = &H9
    sfDesktopDirectory = &H10
    sfStartMenu = &HB
    sfNetHood = &H13
    sfFonts = &H14
    sfShellNew = &H15
    sfAllUsersDektop = &H19
    sfCookies = &H21
    sfHistory = &H22
    sfTemporaryInternetFiles = &H20
    sfProgramFiles = &H26
    sfMedia = &H27
    sfCommon = &H28
    sfConfig = &H29
    sfDevice = &H30
End Enum

Private Type SHITEMID
    cb                 As Long
    abID               As Byte
End Type
Private Type ITEMIDLIST
    mkid               As SHITEMID
End Type

Dim pbData      As New PropertyBag
Public GUI      As Boolean
Public Count    As Integer
Public UsePass  As Boolean
Public Pass     As String
Public PRJ      As String
Public Run()    As String

Public Function CreateDir(ByVal FullDirPath As String) As Boolean
'sluzi da kreira folder. MkDir ne bi mogao da napravi
'folder (npr) "C:\test1\test2" ako "C:\test1" ne postoji. Ova f-ja to moze.
On Error GoTo errH:

    Dim pathArry()  As String
    Dim i           As Integer
    Dim bPath       As String
    Dim strTmp      As String
    Dim mDir        As String
    
    If (InStr(FullDirPath, "\") < 1) Then GoTo errH
    
    pathArry = Split(FullDirPath, "\")
    
    For i = LBound(pathArry) To UBound(pathArry)
    
        strTmp = pathArry(i)
        
        If (Len(strTmp) = 2) And (Mid(strTmp, 2, 1) = ":") Then
            bPath = strTmp & "\" 'drive
            GoTo jump
        End If
        
        mDir = BuildPath(bPath, strTmp)
        
        If (Dir(mDir, vbDirectory) = "") Then MkDir mDir
        
        bPath = mDir & "\"
jump:
    Next
    
    CreateDir = True
    Exit Function
    
errH:
    CreateDir = False
End Function
Public Function GetSpecialFolder(ByVal sFolder As SpecialFolderConstants) As String
'vraca putanju do specijalong foldera
On Error Resume Next

    Dim r       As Long
    Dim IDL     As ITEMIDLIST
    Dim ret     As String
    Dim regy    As clsRegistryAccess
    
    Set regy = New clsRegistryAccess
    
    Select Case sFolder
        Case sfSystem
            ret = Space(255)
            r = GetSystemDirectory(ret, 255)
            ret = Left$(ret, r)
        Case sfTemporary
            ret = String(100, vbNullChar)
            GetTempPath 100, ret
            ret = Left$(ret, InStr(ret, vbNullChar) - 1)
        Case sfWindows
            ret = String(200, vbNullChar)
            r = GetWindowsDirectory(ret, 200)
            ret = Left$(ret, r)
        Case sfProgramFiles
            ret = regy.ReadString("HKLM\Software\Microsoft\Windows\CurrentVersion", "ProgramFilesDir", "C:\Program files")
        Case sfMedia
            ret = regy.ReadString("HKLM\Software\Microsoft\Windows\CurrentVersion", "MediaPath", "C:\WINDOWS\media")
        Case sfConfig
            ret = regy.ReadString("HKLM\Software\Microsoft\Windows\CurrentVersion", "ConfigPath", "C:\WINDOWS\config")
        Case sfCommon
            ret = regy.ReadString("HKLM\Software\Microsoft\Windows\CurrentVersion", "CommonFilesDir", "C:\Program files\Common Files")
        Case sfDevice
            ret = regy.ReadString("HKLM\Software\Microsoft\Windows\CurrentVersion", "DevicePath", "C:\WINDOWS\INF")
        Case Else
            r = SHGetSpecialFolderLocation(100, CLng(sFolder), IDL)
            If r = 0 Then
                Path$ = Space$(512)
                r = SHGetPathFromIDList(ByVal IDL.mkid.cb, ByVal Path$)
                ret = Left$(Path, InStr(Path, Chr$(0)) - 1)
            Else
                ret = ""
            End If
    End Select
    
    Set regy = Nothing
    
    If (Right$(ret, 1) = "\") Then ret = Left$(ret, Len(ret) - 1) 'bez "\" na kraju!
    
    GetSpecialFolder = ret
    
End Function
Function BuildPath(sPath As String, sName As String) As String
    BuildPath = Replace(sPath & "\" & sName, "\\", "\")
End Function
Function setPath(inPath As String) As String

    setPath = Replace(inPath, "$InstallerDirectory", App.Path, , , 1)
    setPath = Replace(setPath, "$AllUsersDektop", GetSpecialFolder(sfAllUsersDektop), , , 1)
    setPath = Replace(setPath, "$Common", GetSpecialFolder(sfCommon), , , 1)
    setPath = Replace(setPath, "$Config", GetSpecialFolder(sfConfig), , , 1)
    setPath = Replace(setPath, "$Cookies", GetSpecialFolder(sfCookies), , , 1)
    setPath = Replace(setPath, "$Desktop", GetSpecialFolder(sfDesktop), , , 1)
    setPath = Replace(setPath, "$DesktopDirectory", GetSpecialFolder(sfDesktopDirectory), , , 1)
    setPath = Replace(setPath, "$Device", GetSpecialFolder(sfDevice), , , 1)
    setPath = Replace(setPath, "$Documents", GetSpecialFolder(sfDocuments), , , 1)
    setPath = Replace(setPath, "$Favorites", GetSpecialFolder(sfFonts), , , 1)
    setPath = Replace(setPath, "$Fonts", GetSpecialFolder(sfFonts), , , 1)
    setPath = Replace(setPath, "$History", GetSpecialFolder(sfHistory), , , 1)
    setPath = Replace(setPath, "$Media", GetSpecialFolder(sfMedia), , , 1)
    setPath = Replace(setPath, "$NetHood", GetSpecialFolder(sfNetHood), , , 1)
    setPath = Replace(setPath, "$ProgramFiles", GetSpecialFolder(sfProgramFiles), , , 1)
    setPath = Replace(setPath, "$Programs", GetSpecialFolder(sfPrograms), , , 1)
    setPath = Replace(setPath, "$Recent", GetSpecialFolder(sfRecent), , , 1)
    setPath = Replace(setPath, "$SendTo", GetSpecialFolder(sfRecent), , , 1)
    setPath = Replace(setPath, "$ShellNew", GetSpecialFolder(sfShellNew), , , 1)
    setPath = Replace(setPath, "$StartMenu", GetSpecialFolder(sfStartMenu), , , 1)
    setPath = Replace(setPath, "$StartUp", GetSpecialFolder(sfStartUp), , , 1)
    setPath = Replace(setPath, "$System", GetSpecialFolder(sfSystem), , , 1)
    setPath = Replace(setPath, "$Temp", GetSpecialFolder(sfTemporary), , , 1)
    setPath = Replace(setPath, "$TemporaryInternetFiles", GetSpecialFolder(sfTemporaryInternetFiles), , , 1)
    setPath = Replace(setPath, "$Windows", GetSpecialFolder(sfWindows), , , 1)

End Function
Sub WriteFile(sFileData As String, sOutput As String)
    Dim ff As Integer
    
    On Error Resume Next
    sOutput = setPath(sOutput)
    CreateDir getDir(sOutput)
    

    Kill sOutput 'ako vec postoji
    'ako je doslo do greske prilikom brisanja fajla:
    If Err.Number <> 0 And Err.Number <> 53 Then Exit Sub

    ff = FreeFile

    Open sOutput For Binary As #ff
        Put #ff, , sFileData
    Close #ff
    
End Sub
Sub readME()
    'ova funkcija cita sta je zapisano u exe-u
    
    Dim pos     As Long
    Dim vData   As Variant
    Dim ff      As Integer
    Dim B()     As Byte
        
    On Error GoTo proc_exit
    
    ff = FreeFile
    Open App.Path & "\" & App.EXEName & ".exe" For Binary As #ff
    
        Get #ff, LOF(ff) - 3, pos 'odavde citamo podatke
        Seek #ff, pos 'postavljamom pointer na to mesto
        Get #ff, , vData 'i citamo podatke
        B = vData
        
    Close #ff
    
    pbData.Contents = B 'ucitavamo podatke u propertybag
    
    GUI = pbData.ReadProperty("gui", True)
    
    PRJ = pbData.ReadProperty("Project", "Default")
    
    frmMain.Caption = "[K] Installer - " & PRJ
    
    Count = pbData.ReadProperty("u", 0)
    
    If Count = 0 Then GoTo proc_exit
    
    UsePass = pbData.ReadProperty("p", False)
    If UsePass And GUI Then
        Pass = pbData.ReadProperty("0#0")
    End If
    
    Exit Sub
    
proc_exit:
    APPExit
End Sub
Public Sub Unpack()
    Dim i           As Integer
    Dim r           As Integer
    Dim FileBin     As String
    Dim Filepath    As String
    Dim RunParam    As Integer
    
    For i = 1 To Count
        On Error Resume Next
    
        FileBin = pbData.ReadProperty("b" & i)
        Filepath = pbData.ReadProperty("o" & i)
        RunParam = pbData.ReadProperty("r" & i)
    
        
        Call WriteFile(FileBin, Filepath)
        DoEvents
        
        Select Case RunParam
            Case 1
                On Error Resume Next
                r = UBound(Run) + 1
                ReDim Preserve Run(i) As String
                'fajl ce biti pokrenut kada se svi ostali raspakuju
                Run(i) = Filepath
            Case 2
                'pokrecemo fajl odma'
                RunFile (Filepath)
                DoEvents
        End Select
    Next
    DoEvents: DoEvents
    'svi su raspakovani, sada da pokrenemo selektovane
    For i = LBound(Run) To UBound(Run)
        'pokrecemo fajl
        RunFile Run(i)
        DoEvents
    Next
    
End Sub
Sub RunFile(TargetFile As String)
    On Error Resume Next
    If Dir(TargetFile) = "" Then Exit Sub
    ShellExecute frmMain.hwnd, "open", TargetFile, vbNullString, App.Path, 1
End Sub
Function getDir(Fullpath As String) As String
    getDir = Left$(Fullpath, InStrRev(Fullpath, "\"))
End Function
Public Sub APPExit()
    On Error Resume Next
    Unload frmMain
    Reset
    End '!
End Sub
